
#include "warpmac.h"
#include "warpphy.h"
#include "xparameters.h"
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include "xutil.h"
#include "xcache_l.h"
#include "xexception_l.h"
#include "xcache_l.h"
#include "xutil.h"
#include "xexception_l.h"
#include "ofdm_timer.h"

Macframe rxBuffer;

unsigned int index = 0;
unsigned char antSel = 0;
unsigned int numPkts = 0;


///@brief Callback for the reception of bad wireless packets
///
///@param packet Pointer to received Macframe
int receiveBadPacket(Macframe* packet) {
	warpmac_incrementLEDLow();
}

///@brief Callback for the reception of good wireless packets
///
///This function first determines if the destination of the packet was this node.
///If so, it sends an #ACKPACKET if the received packet was a #DATAPACKET,
///and pushes the received packet over Ethernet. If the received packet
///was an #ACKPACKET, the #TIMEOUT is stopped. 
///@param packet Pointer to received Macframe
int receiveGoodPacket(Macframe* packet) {
	
	warpmac_incrementLEDHigh();

	
	
	if(antSel==0){
		warpmac_leftHexBit((index++)%7);
	}
	
	if(antSel==1){
		warpmac_rightHexBit((index++)%7);
	}

	return 0;
}


///@brief Main function
///
///This function configures MAC parameters, enables the underlying frameworks, and then loops forever.
int main(){

	
	
	//Initialize the framework
	warpmac_init();
	warpmac_setRxBuffer(&rxBuffer,0);
	warpmac_setTxBuffer(1);
	warpmac_setGoodPacketHandler(receiveGoodPacket);
	warpmac_setBadPacketHandler(receiveBadPacket);
	warpmac_setChannel(GHZ_2,8);

	//Set the modulation scheme use for base rate (header) symbols
	warpmac_setBaseRate(QPSK);
	
	warpphy_setSISOAntenna(antSel);
	

	while(1){

			usleep(100000 + 5*(rand()>>25));
			Macframe dummy;
			dummy.header.length = 1400;
			dummy.header.fullRate = QPSK;
			//warpmac_sendOfdm(&dummy);
			numPkts++;	   
		
		if(numPkts%20 == 0) {
			antSel = (antSel+1)%2;
			warpphy_setSISOAntenna(antSel);
		}
	}

	return;
}




